schedule function horse_traps:1t 1t

#UUID STORE
execute as @a run execute store result score @s horse_traps.uid0 run data get entity @s UUID[0]
execute as @a run execute store result score @s horse_traps.uid1 run data get entity @s UUID[1]
execute as @a run execute store result score @s horse_traps.uid2 run data get entity @s UUID[2]
execute as @a run execute store result score @s horse_traps.uid3 run data get entity @s UUID[3]

#HORSE STATS
attribute @e[type=skeleton_horse,tag=!horse_traps.despawn,tag=!horse_traps.stats,tag=!smithed.entity,sort=nearest,limit=1] minecraft:movement_speed base set 0.3
attribute @e[type=zombie_horse,tag=!horse_traps.despawn,tag=!horse_traps.stats,tag=!smithed.entity,sort=nearest,limit=1] minecraft:jump_strength base set 1
tag @e[type=#horse_traps:undead_horse,tag=!horse_traps.despawn,tag=!horse_traps.stats,tag=!smithed.entity] add horse_traps.stats

#UNTAME HORSES
execute as @e[type=#horse_traps:undead_horse,tag=horse_traps.poison] at @s run execute unless data entity @s Passengers run data merge entity @s {Tame:0b}

#HORSES EAT GOLDEN APPLE
execute as @e[type=#horse_traps:undead_horse,tag=!horse_traps.despawn,tag=!smithed.entity,limit=10,sort=random] at @s run execute if entity @e[type=item,distance=..1,nbt={Item:{id:"minecraft:golden_apple",count:1}}] run function horse_traps:eat/golden_apple
execute as @e[type=#horse_traps:undead_horse,tag=!horse_traps.despawn,tag=!smithed.entity,limit=10,sort=random] at @s run execute if entity @e[type=item,distance=..1,nbt={Item:{id:"minecraft:enchanted_golden_apple",count:1}}] run function horse_traps:eat/enchanted_golden_apple

#REPLACE WITH NORMAL HORSES
execute as @e[type=skeleton_horse,tag=horse_traps.despawn,tag=!horse_traps.poison,tag=!horse_traps.zombie_h] at @s run execute unless data entity @s Passengers run function horse_traps:replace/skeleton_horse
execute as @e[type=skeleton_horse,tag=horse_traps.despawn,tag=!horse_traps.poison,tag=horse_traps.zombie_h] at @s run execute unless data entity @s Passengers run function horse_traps:replace/zombie_horse

#CHOOSE
execute as @e[tag=horse_traps.trap,tag=!horse_traps.skeleton,tag=!horse_traps.zombie,predicate=horse_traps:chance_10] at @s run execute unless score horse_traps.sc horse_traps.swit matches 1 run execute unless score horse_traps.sc horse_traps.swit matches 3 run tag @s add horse_traps.skeleton
execute as @e[tag=horse_traps.trap,tag=!horse_traps.skeleton,tag=!horse_traps.zombie,predicate=horse_traps:chance_10] at @s run execute unless score horse_traps.sc horse_traps.swit matches 0 run execute unless score horse_traps.sc horse_traps.swit matches 3 run tag @s add horse_traps.zombie

#ZOMBIE HORSE JUMP TWEAKS
execute as @e[type=zombie_horse,predicate=!horse_traps:has/jump_boost,tag=!smithed.entity] at @s run attribute @s minecraft:jump_strength base set 1

#ZOMBIE HORSE HURT SOUND
execute as @e[type=skeleton_horse,tag=horse_traps.zombie_h,nbt={HurtTime:9s}] at @s run playsound entity.zombie_horse.hurt neutral @a ~ ~ ~

#ZOMBIE HORSE DEATH SOUND
execute as @e[type=item,nbt={Item:{components:{"minecraft:custom_data":{horse_traps.zombie_h_death:1b}}}}] at @s run playsound entity.zombie_horse.death neutral @a ~ ~ ~
kill @e[type=item,nbt={Item:{components:{"minecraft:custom_data":{horse_traps.zombie_h_death:1b}}}}]

#WARN
execute as @e[type=lightning_bolt,tag=!smithed.entity,tag=!smithed.strict] at @s run execute unless entity @e[type=trident,nbt={inGround:0b},distance=..6] run advancement grant @a[gamemode=!spectator,distance=..110,advancements={horse_traps:warn=false}] only horse_traps:warn

#RENAME BUG
execute as @e[type=skeleton_horse,name="Zombie Horse",tag=!horse_traps.zombie_h] at @s run data modify entity @s CustomName set value '{"text":"Zombie horse"}'
execute as @e[type=skeleton_horse,name=!"Zombie Horse",tag=horse_traps.zombie_h] at @s run data modify entity @s CustomName set value '{"text":"Zombie Horse"}'

#BOSSBARS
execute as @e[type=skeleton,tag=horse_traps.angryat] at @s run scoreboard players set @a[distance=..64] horse_traps.sb 1
execute as @e[type=drowned,tag=horse_traps.angryat] at @s run scoreboard players set @a[distance=..64] horse_traps.zb 1

#SKELETON HORSE TRAP BOSSBAR VALUE
scoreboard players set horse_traps.val horse_traps.s 0
execute as @e[type=skeleton,tag=horse_traps.fire_resistant] run function horse_traps:bossbar/value/skeleton
execute as @e[type=skeleton_horse,tag=horse_traps.poison,tag=!horse_traps.zombie_h] run function horse_traps:bossbar/value/skeleton
execute store result bossbar horse_traps:skeleton value run scoreboard players get horse_traps.val horse_traps.s

#ZOMBIE HORSE TRAP BOSSBAR VALUE
scoreboard players set horse_traps.val horse_traps.z 0
execute as @e[type=drowned,tag=horse_traps.fire_resistant] run function horse_traps:bossbar/value/zombie
execute as @e[type=skeleton_horse,tag=horse_traps.poison,tag=horse_traps.zombie_h] run function horse_traps:bossbar/value/zombie
execute store result bossbar horse_traps:zombie value run scoreboard players get horse_traps.val horse_traps.z

#HORSE TRAP
execute as @e[type=#horse_traps:replaceable,tag=!smithed.entity,tag=!horse_traps.entity,predicate=horse_traps:overworld,predicate=horse_traps:chance_5] at @s run execute if predicate horse_traps:thunder run execute if predicate horse_traps:chance_5 run function horse_traps:spawn/trap
tag @e[type=#horse_traps:replaceable,tag=!horse_traps.entity,tag=!smithed.entity] add horse_traps.entity
execute as @e[tag=horse_traps.trap] at @s run execute if entity @a[gamemode=!creative,gamemode=!spectator,distance=..25] run function horse_traps:trap/spawn
execute as @e[tag=horse_traps.zombie] at @s run execute if entity @e[type=villager,tag=!smithed.entity,tag=!smithed.strict,nbt=!{Invulnerable:1b},distance=..16] run function horse_traps:trap/zombie_horsemen
execute as @e[tag=horse_traps.zombie] at @s run execute if entity @e[type=wandering_trader,tag=!smithed.entity,tag=!smithed.strict,nbt=!{Invulnerable:1b},distance=..16] run function horse_traps:trap/zombie_horsemen

#STACK
execute as @e[type=skeleton_horse,limit=1,sort=random,tag=horse_traps.fire_resistant,tag=horse_traps.zombie_h] at @s run execute if entity @e[type=drowned,tag=horse_traps.angryat,predicate=horse_traps:angry,distance=..7] run tp @e[type=skeleton_horse,tag=horse_traps.fire_resistant,tag=horse_traps.zombie_h,distance=0.1..2] ~ ~ ~

#CHANNELING
execute as @e[type=trident,nbt={inGround:0b,pickup:0b},tag=!horse_traps.channeling] at @s run execute if entity @e[type=drowned,tag=horse_traps.angryat,distance=..2] run tag @s add horse_traps.channeling
execute as @e[type=trident,nbt={inGround:0b,pickup:0b},tag=horse_traps.channeling] at @s run execute at @e[team=!horse_traps.men,sort=nearest,limit=1,nbt={HurtTime:9s},distance=..3] run execute unless entity @e[team=horse_traps.men,distance=..4] run function horse_traps:channeling

#REPLACE DEFAULT HORSE TRAP
execute as @e[type=skeleton_horse,nbt={SkeletonTrap:1b}] at @s run function summon:horse_traps/trap
execute as @e[type=skeleton_horse,nbt={SkeletonTrap:1b}] at @s run function horse_traps:delete_current_entity